org.fourthline.cling.model.action

## Class ActionInvocation<S extends Service>

- java.lang.Object
- - org.fourthline.cling.model.action.ActionInvocation<S>

- Direct Known Subclasses:
    RemoteActionInvocation

      public class ActionInvocation<S extends Service>
      extends Object

  The input, output, and failure values of an action invocation.
  Author:
    Christian Bauer

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Action<S>` | `action`
    `protected ClientInfo` | `clientInfo`
    `protected ActionException` | `failure`
    `protected Map<String,ActionArgumentValue<S>>` | `input`
    `protected Map<String,ActionArgumentValue<S>>` | `output`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ActionInvocation(Action<S> action)`
    `ActionInvocation(Action<S> action, ActionArgumentValue<S>[] input)`
    `ActionInvocation(Action<S> action, ActionArgumentValue<S>[] input, ActionArgumentValue<S>[] output)`
    `ActionInvocation(Action<S> action, ActionArgumentValue<S>[] input, ActionArgumentValue<S>[] output, ClientInfo clientInfo)`
    `ActionInvocation(Action<S> action, ActionArgumentValue<S>[] input, ClientInfo clientInfo)`
    `ActionInvocation(Action<S> action, ClientInfo clientInfo)`
    `ActionInvocation(ActionException failure)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Action<S>` | `getAction()`
    `ClientInfo` | `getClientInfo()`
    `ActionException` | `getFailure()`
    `ActionArgumentValue<S>[]` | `getInput()`
    `ActionArgumentValue<S>` | `getInput(ActionArgument<S> argument)`
    `ActionArgumentValue<S>` | `getInput(String argumentName)`
    `protected ActionArgument<S>` | `getInputArgument(String name)`
    `Map<String,ActionArgumentValue<S>>` | `getInputMap()`
    `ActionArgumentValue<S>[]` | `getOutput()`
    `ActionArgumentValue<S>` | `getOutput(ActionArgument<S> argument)`
    `ActionArgumentValue<S>` | `getOutput(String argumentName)`
    `protected ActionArgument<S>` | `getOutputArgument(String name)`
    `Map<String,ActionArgumentValue<S>>` | `getOutputMap()`
    `void` | `setFailure(ActionException failure)`
    `void` | `setInput(ActionArgumentValue<S> value)`
    `void` | `setInput(ActionArgumentValue<S>[] input)`
    `void` | `setInput(String argumentName, Object value)`
    `void` | `setOutput(ActionArgumentValue<S> value)`
    `void` | `setOutput(ActionArgumentValue<S>[] output)`
    `void` | `setOutput(String argumentName, Object value)`
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### action

          protected final Action<S extends Service> action

    - #### clientInfo

          protected final ClientInfo clientInfo

    - #### input

          protected Map<String,ActionArgumentValue<S extends Service>> input

    - #### output

          protected Map<String,ActionArgumentValue<S extends Service>> output

    - #### failure

          protected ActionException failure

  - ### Constructor Detail

    - #### ActionInvocation

          public ActionInvocation(Action<S> action)

    - #### ActionInvocation

          public ActionInvocation(Action<S> action,
                                  ClientInfo clientInfo)

    - #### ActionInvocation

          public ActionInvocation(Action<S> action,
                                  ActionArgumentValue<S>[] input)

    - #### ActionInvocation

          public ActionInvocation(Action<S> action,
                                  ActionArgumentValue<S>[] input,
                                  ClientInfo clientInfo)

    - #### ActionInvocation

          public ActionInvocation(Action<S> action,
                                  ActionArgumentValue<S>[] input,
                                  ActionArgumentValue<S>[] output)

    - #### ActionInvocation

          public ActionInvocation(Action<S> action,
                                  ActionArgumentValue<S>[] input,
                                  ActionArgumentValue<S>[] output,
                                  ClientInfo clientInfo)

    - #### ActionInvocation

          public ActionInvocation(ActionException failure)

  - ### Method Detail

    - #### getAction

          public Action<S> getAction()

    - #### getInput

          public ActionArgumentValue<S>[] getInput()

    - #### getInput

          public ActionArgumentValue<S> getInput(String argumentName)

    - #### getInput

          public ActionArgumentValue<S> getInput(ActionArgument<S> argument)

    - #### getInputMap

          public Map<String,ActionArgumentValue<S>> getInputMap()

    - #### getOutput

          public ActionArgumentValue<S>[] getOutput()

    - #### getOutput

          public ActionArgumentValue<S> getOutput(String argumentName)

    - #### getOutputMap

          public Map<String,ActionArgumentValue<S>> getOutputMap()

    - #### getOutput

          public ActionArgumentValue<S> getOutput(ActionArgument<S> argument)

    - #### setInput

          public void setInput(String argumentName,
                               Object value)
                        throws InvalidValueException

      Throws:
        `InvalidValueException`

    - #### setInput

          public void setInput(ActionArgumentValue<S> value)

    - #### setInput

          public void setInput(ActionArgumentValue<S>[] input)

    - #### setOutput

          public void setOutput(String argumentName,
                                Object value)
                         throws InvalidValueException

      Throws:
        `InvalidValueException`

    - #### setOutput

          public void setOutput(ActionArgumentValue<S> value)

    - #### setOutput

          public void setOutput(ActionArgumentValue<S>[] output)

    - #### getInputArgument

          protected ActionArgument<S> getInputArgument(String name)

    - #### getOutputArgument

          protected ActionArgument<S> getOutputArgument(String name)

    - #### getFailure

          public ActionException getFailure()

      Returns:
        `null` if execution was successful, failure details otherwise.

    - #### setFailure

          public void setFailure(ActionException failure)

    - #### getClientInfo

          public ClientInfo getClientInfo()

      Returns:
        `null` if no info was provided for a local invocation.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2016 4th Line GmbH, Switzerland. All rights reserved.